from lib.obter_configuracoes import obter_configuracoes
import sys
from lib.echo import echo
from lib.executar_validacoes_servidor_linux import executar_validacoes_servidor_linux
from lib.ClienteLinux import obter_cliente_linux

arquivo_configuracao = None if len(sys.argv) < 2 else sys.argv[1]
diretorio_scripts_implantacao = r'c:\microuniversoWeb\scriptsImplantacao' if len(sys.argv) < 3 else sys.argv[2]

configuracoes = obter_configuracoes(arquivo_configuracao)

if not configuracoes["acessos"]["servidorLinux"]["configurar"]:
    echo("Dados do servidor linux nao informados. Site de Configuracao Web nao sera configurado")
    exit(0)

if not configuracoes["muWhatsapp"]["configurarApi"]:
    echo("Site de Configuracao Web desativada via configuracao")
    exit(0)

mensagem_erro = executar_validacoes_servidor_linux(arquivo_configuracao, diretorio_scripts_implantacao)    

if mensagem_erro:
    echo(mensagem_erro, "error")
    exit(1)

cliente_linux = obter_cliente_linux(arquivo_configuracao)

usuario = configuracoes['acessos']['servidorLinux']['usuario']

cliente_linux.executar_comando(f'mkdir -p /home/{usuario}/ConfiguracoesWeb')

cliente_linux.copiar_arquivo(fr'{diretorio_scripts_implantacao}\configuracoesWeb\docker-compose-configuracoes-web.yml' , f'/home/{usuario}/ConfiguracoesWeb/docker-compose.yml')

url_api_enterprise = "{protocolo}://{host}:{porta}".format(
    protocolo="http",
    host= configuracoes['acessos']['servidorLinux']['host'],
    porta=configuracoes["enterprise"]["porta"]
)


versao = configuracoes["configuracoesWeb"]["versao"]
porta = configuracoes["configuracoesWeb"]["porta"]
versao_mu_whatsapp_api = configuracoes["muWhatsapp"]["versao"]

usuario_registro_docker = configuracoes["acessos"]["registroDocker"]["usuario"]
senha_registro_docker = configuracoes["acessos"]["registroDocker"]["senha"]

cliente_linux.executar_comando(fr'docker login gitlab.microuniverso.com.br:5050 -u {usuario_registro_docker} -p {senha_registro_docker}', disparar_excecao_se_retorno_nao_zero=False)

cliente_linux.executar_comando(fr"sed -i 's,\$URL_API_ENTERPRISE,{url_api_enterprise},g' /home/{usuario}/ConfiguracoesWeb/docker-compose.yml")

cliente_linux.executar_comando(fr"sed -i 's,\$VERSAO_CONFIGURACOES_WEB,{versao},g' /home/{usuario}/ConfiguracoesWeb/docker-compose.yml")
cliente_linux.executar_comando(f"sed -i 's,\$PORTA,{porta},g' /home/{usuario}/ConfiguracoesWeb/docker-compose.yml")
cliente_linux.executar_comando(f"sed -i 's,\$VERSAO_MU_WHATSAPP_API,{versao_mu_whatsapp_api},g' /home/{usuario}/ConfiguracoesWeb/docker-compose.yml")

cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/ConfiguracoesWeb/docker-compose.yml down')    
cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/ConfiguracoesWeb/docker-compose.yml up -d')    

exit(0)

